/**
 * @file avlnode.h
 */

#ifndef __AVLNODE_H
#define __AVLNODE_H

#include <stdio.h>

#include "avlnode.h"
#include "avltree.h"

#define xnew(T)     ((T *)calloc(1, sizeof(T)))
#define xfree(P)    (free(P))

typedef struct _Node AvlNode;

struct _Node    
{
  void* key;
  void* value;
  TREE_ENTRY(_Node)	tree;
};

typedef TREE_HEAD(tree, _Node) AvlTree;


/**
 *
 */
AvlNode *AvlNode_new(void* key, void* value);

/**
 *
 */
int AvlNode_compare(AvlNode *lhs, AvlNode *rhs);

/**
 *
 */
void AvlNode_print(AvlNode *self, FILE *stream);

/**
 *
 */
void AvlNode_printer(AvlNode *self, void *stream);

#endif